#include "requests.h"

#include <stdlib.h>

static int post_request_vp_i (int req, void *vp, int i);

struct request
{
    int req;
    void *vp;
    int i;

    struct request *next;
};

static struct request *head, *tail;

/* the doctor said i wouldn't have so many nosebleeds if i kept my finger 
out of there */

int post_request (int req)
{
    return post_request_vp_i (req, NULL, 0);
}

int post_request_vp (int req, void *vp)
{
    return post_request_vp_i (req, vp, 0);
}

int post_request_i (int req, int i)
{
    return post_request_vp_i (req, NULL, i);
}

static int post_request_vp_i (int req, void *vp, int i)
{
    struct request *request;

    if ((request = malloc (sizeof (struct request))) == NULL)
        return 0;

    request->req = req;
    request->vp = vp;
    request->i = i;
    request->next = NULL;

    if (tail)
    {
        tail->next = request;
        tail = request;
    }
    else
    {
        head = request;
        tail = request;
    }

    return 1;
}

int is_request (void)
{
    return ! ! head;
}

int peek_request (void)
{
    return head ? head->req : 0;
}

void *peek_vp (void)
{
    return head ? head->vp : 0;
}

int peek_i (void)
{
    return head ? head->i : 0;
}

int peek_count (int req)
{
    struct request *p;
    int c;

    for (p = head, c = 0; p; p = p->next)
        if (p->req == req)
            c++;

    return c;
}

void pop_request (void)
{
    if (head)
    {
        struct request *oh;

        oh = head;
        if ((head = head->next) == NULL)
            tail = NULL;

        free (oh);
    }
}
