#include "card.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *open_file (char **argv);
void print_card (struct card *card);

int main (int argc, char *argv[])
{
    FILE *f;
    struct card *cards;
setvbuf (stdout, NULL, _IONBF, 0);
    f = open_file (argv);
    cards = parse_cardfile (f);
    fclose (f);

    foreach_card (cards, print_card);

    delete_cardfile (cards);

    return 0;
}

FILE *open_file (char **argv)
{
    FILE *f;

    if (argv[1] == NULL)
    {
        printf ("Must specify cardfile.\n");
        printf ("Syntax: %s <cardfile>", argv[0]);
        exit (1);
    }

    if ((f = fopen (argv[1], "rb")) == NULL)
    {
        printf ("Cardfile %s not found.\n", argv[1]);
        exit (1);
    }

    return f;
}

void print_card (struct card *card)
{
    int row, title_length, text_length;

    char title_buffer[TITLE_WIDTH + 1];
    char  text_buffer[ TEXT_WIDTH + 1];

    get_title (card, title_buffer, &title_length);
    title_buffer[title_length] = '\0';
    puts (title_buffer);

    memset (title_buffer, '-', TITLE_WIDTH);
    title_buffer[TITLE_WIDTH] = '\0';
    puts (title_buffer);

    for (row = 0; ; row++)
    {
    	if (! get_row (card, text_buffer, &text_length, row))
    		break;
    	text_buffer[text_length] = '\0';
    	chop_text_linefeed (text_buffer, text_length, '\0');
    	puts (text_buffer);
    }

    putchar ('\n');
}

