/* Makes a sample cardfile with 256 entries tagged with provided text */
/* Call: writer file.crd text */

/* Useful mainly in discovering Windows cardfile sorting order; can sometimes
   use "merge" function to do so. On some cardfile versions "merge" does not
   assume one file is presorted. The sample text allows throwing away the
   unwanted file */

#include "card.h"
#include "sort_order.h"

#include <stdio.h>
#include <string.h>

struct card *make_cardfile (char *s)
{
    struct card *cardfile, *p;
    int i;
    char title[4] = { 'A', 'A', 0, 'A' };

    cardfile = alloc_blank_cardfile (256);
    for (i = 0, p = cardfile; i < 256; i++, p = p->next)
    {
        title[2] = forward[i];
        set_title (p, title, 4);
        p->text_length = sprintf (p->text, "Card %s%c#%d", s, " "[!s[0]], i);
    }

    return cardfile;
}

int main (int argc, char *argv[])
{
    FILE *f;
    struct card *cardfile;
    char buf[20];

    if (argc < 3) return 1;

    strcpy (buf, argv[1]);
    /* This program has such a limited purpose that it is all right handling
       extensions so poorly */
    if (! strstr (buf, ".crd") && ! strstr (buf, ".CRD"))
        strcat (buf, ".crd");
    f = fopen (buf, "wb");
    if (!f) return 1;

    /* argv[2] is the user-provided tag text */
    cardfile = make_cardfile (argv[2]);
    write_cardfile (f, cardfile);
    delete_cardfile (cardfile);

    fclose (f);
    return 0;
}
